/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 * 
 * (C) Copyright IBM Corp. 2011 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
/* IBM_COPYRIGHT_END */

/* 
 * Licensed Materials - Property of IBM
 * 
 * TIVOTCT00
 * 
 * Restricted Materials of IBM
 * 
 * Copyright IBM Corp. 2011, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or 
 * disclosure restricted by GSA ADP Schedule Contract with 
 * IBM Corp. 
 */

dojo.provide("navwidget.dijit.ResExpNavWidget");
dojo.provide("navwidget.dijit.ResExpNavWidgetMenuProvider");

dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidget");
dojo.require("navwidget.topology.dijit.ResExpMenuProviderHelper");


dojo.declare ("navwidget.dijit.ResExpNavWidget",
	[ibm.tivoli.tip.navwidget.dijit.NavWidget],
	{		
		// cmProvider:
		//		Custom context menu provider (must be provided on construction to be used)
		cmProvider: null,	
		

		
		_createCMProvider: function(){		
			// summary:
			//		Coming soon
			// description:
			//		Coming soon
			
			//Create the menu provider that we'll pass off to the pluggable views
			if (!this.cmProvider) {
				var helper = new navwidget.topology.dijit.ResExpMenuProviderHelper();
				this.cmProvider = new navwidget.dijit.ResExpNavWidgetMenuProvider({
	                				view: this,
	                				getMenuItemsCallback: dojo.hitch(helper, helper.getMenuItems),
	                				getMenuCommandCallback: dojo.hitch(helper, helper.getMenuCommand)
				});
			}
			
			this.inherited(arguments);
		}
	});
	
dojo.declare("navwidget.dijit.ResExpNavWidgetMenuProvider",
        ibm.tivoli.tip.navwidget.dijit.RESTContextMenuProvider,
{		
	// summary:
	//		Coming soon
	// description:
	//		Coming soon
	
	// _handle:
	//		
	_handle: null,
	
	filterNavigationTasks: function(/*ibm.tivoli.navmodel.Task[]*/ tasks) {
		// summary:
		//	Return a filtered collection of tasks (i.e. remove all navigation tasks)
		//
		// Overriding this method because we do NOT want to filter out navigation tasks
		return tasks;
	},

	handleNavigation: function(data, ioArgs) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// data: 
		//		
		// ioArgs:
		//		
	
		// listen for event indicating new dataset is loaded and dismiss the busy pane
		this._handle = dojo.connect(this.view, "onSetDataset", this, function(dataset) {
																			this.view.hideBusyPane();
																			dojo.disconnect(this._handle);});
		this.view.showBusyPane();
		this.view.getCurrentDataset().navigate(
   	         {onComplete: dojo.hitch(this, this._processNavNewDataSet),
   	         onError: dojo.hitch(this, this._handleNavNewDataSetError),
   	         taskId: data.actionID,
   	         taskCategory: data.category,
   	         selection: this.buildClientNavModelSelection(data, this.view.dataset.getVersion())});
	},
	
	_processNavNewDataSet: function(dataset, kwArgs) {	
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// dataset: 
		//		
		// kwArgs:
		//		
		this.view.addDataset(dataset);
	},

	_handleNavNewDataSetError: function(error, exception, ioArgs) {		
		// summary:
		//		Coming soon
		// description:
		//		Coming soon
		// error: 
		//		
		// exception:
		//		
		// ioArgs:
		//		
		
		// in case of an error, dismiss the busy pane
		this.view.hideBusyPane();
		dojo.disconnect(this._handle);
		
		//Give the user some feedback
        this.view.displayException(error);
	}
	
});


