/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 * 
 * (C) Copyright IBM Corp. 2011 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
/* IBM_COPYRIGHT_END */

dojo.provide("resexp.ResExplorerTreeView");

dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.Tree");
dojo.require("dijit.tree.ForestStoreModel");
dojo.require("ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView");
dojo.require("ibm.tivoli.tip.navwidget.tree.dijit.TreeTableView");
dojo.require("ibm.tivoli.navmodel.DatasetTreeStore");
dojo.requireLocalization("resexp", "resources");

dojo.declare("resexp.ResExplorerTreeView",
	[dijit.layout.BorderContainer, ibm.tivoli.tip.navwidget.dijit.NavWidgetPluggableView],
{
	_tree: null,
      
	constructor: function(kwArgs) {
		this._resExplorerResources = dojo.i18n.getLocalization("resexp", "resources");
	    this.title = "Tree View"; //TODO: MRI this._resExplorerResources.NAV_WIDGET_CUSTOM_VIEW1;

        //We don't have a widget def specific to this view, so let's signal to 
        //super class not to try and load any widget defs on our behalf
		this._usesWidgetDefinition = false;
    },
        
    destroy: function() {
		this.inherited(arguments);
    },
	
    _setDatasetLoadData: function(dataset){
    	//Destroy old tree
    	if (this._tree) {
    		this.removeChild(this._tree);
    		this._tree.destroyRecursive();
    		this._tree = null;
    	}
    	
    	//Load in the default widget def for the view
		var WIDGET_DEF_INFO = {
			className: "ibm.tivoli.navmodel.TreeTableWidgetDef",
			baseUrl: "/ibm/tivoli/rest",
			provider: "any",
			datasource: "any",
			widget: "treetable",
			definition: "DefaultTreeTable"
		};
		var widgetDefinition
				= ibm.tivoli.tip.navwidget.dojo.NavWidgetUtil.createWidgetDefinition(WIDGET_DEF_INFO.className,
						WIDGET_DEF_INFO.definition, WIDGET_DEF_INFO, dataset, null);

		//Make changes to the widget def (like specify custom column info)
		if (widgetDefinition) {
			widgetDefinition.getToolbar().hidden=true;
			// widgetDefinition.setTablesSelectionMode('single');
		}
		
    	this._tree = new ibm.tivoli.tip.navwidget.tree.dijit.TreeTableView({
			id: "resExplorerTreeView",
			dataset: dataset,
			widgetDefinition: widgetDefinition
		});
		
    	this.addChild( this._tree );

        //Listen for selection change
		dojo.connect(this._tree.selection, "onSelectionChanged", dojo.hitch(this, this._navWidgetSelectionChangedHandler));
			
    	//Call superclass
    	this.inherited(arguments);
    },
	
    
	//handler for selection changes
	_navWidgetSelectionChangedHandler: function(objectContext) {
			var items = objectContext.getItems();
			this.selection.setSelectedItem(items[0]);

	}
});

